C. Journey

CodeForces – 839C 

There are n cities and n - 1 roads in the Seven Kingdoms, each road connects two cities and we can reach any city from any other by the roads.

Theon and Yara Greyjoy are on a horse in the first city, they are starting traveling through the roads. But the weather is foggy, so they can’t see where the horse brings them. When the horse reaches a city (including the first one), it goes to one of the cities connected to the current city. But it is a strange horse, it only goes to cities in which they weren’t before. In each such city, the horse goes with equal probabilities and it stops when there are no such cities.

Let the length of each road be 1. The journey starts in the city 1. What is the expected length (expected value of length) of their journey? You can read about expected (average) value by the link https://en.wikipedia.org/wiki/Expected_value.Input

The first line contains a single integer n (1 ≤ n ≤ 100000) — number of cities.

Then n - 1 lines follow. The i-th line of these lines contains two integers u i and v i (1 ≤ u i, v i ≤ nu i ≠ v i) — the cities connected by the i-th road.

It is guaranteed that one can reach any city from any other by the roads.Output

Print a number — the expected length of their journey. The journey starts in the city 1.

Your answer will be considered correct if its absolute or relative error does not exceed 10 - 6.

Namely: let’s assume that your answer is a, and the answer of the jury is b. The checker program will consider your answer correct, if .ExamplesInput

4
1 2
1 3
2 4

Output

1.500000000000000

Input

5
1 2
1 3
3 4
2 5

Output

2.000000000000000

Note

In the first sample, their journey may end in cities 3 or 4 with equal probability. The distance to city 3 is 1 and to city 4 is 2, so the expected length is 1.5.

In the second sample, their journey may end in city 4 or 5. The distance to the both cities is 2, so the expected length is 2.


思路:期望=概率*权值

所以我们求出一棵树上到叶节点的概率和权值,然后乘起来再相加就是期望

设f[i]代表从1号节点走到i号节点的概率,deep代表i号节点的深度(设1好节点深度为0).

求deep就直接在树上dfs一遍就可以拿出deep[i];

然后我们要求概率,这里要想清楚不然容易出错,我因此直接在原来的树再遍历改了好久发现都不对最后领悟。

假设一个最简单的树。1-2和1-3

那么i节点到与之相连的节点的概率是1.0/son[i](son[i])表示i节点的子节点个数。

也就是说这里的son[1]=2,也就是f[1]=0.5;

这里理解剩下就类似递推

假设一个点u,那么到u的概率就是f[u]=f[fa[u]]*(1.0/son[u].size()); ///注意是son[u].size(); 【因为我们直接把叶节点的size看成是1而不是直接建双向边的2】

所以下面代码是重新建树,建一棵子节点size==0的树 ,方便做也正确做

#include<iostream>
#include<vector>
#include<queue>
#include<cstring>
#include<cmath>
#include<cstdio>
#include<algorithm>
using namespace std;
const int maxn=2e5;
typedef long long LL;
LL deep[maxn],fa[maxn];//f[i]表示起点到i点的概率。改部分期望为ans+=f[fa[i]]*(1.0/son[i])*deep[left] 
double f[maxn];
bool vis[maxn];
vector<LL>tree[maxn];
double ans=0;
LL n,m;
void dfs(LL u,LL father,LL depth)
{
	deep[u]=depth+1;
	fa[u]=father;
	vis[u]=1;
	for(LL i=0;i<tree[u].size();i++)
	{
		LL v=tree[u][i];
		if(vis[v]||v==father) continue;
		dfs(v,u,depth+1);
	}
}
void dfs2(LL u)
{
	vis[u]=1;
	if(!tree[u].size()) ans+=f[fa[u]]*deep[u];
	else
	{
		f[u]=f[fa[u]]*(1.0/tree[u].size());
		for(LL i=0;i<tree[u].size();i++)
		{
			LL v=tree[u][i];
			if(!vis[v])
			dfs2(v);
		}
	}
}
int main(void)
{
//  cin.tie(0);std::ios::sync_with_stdio(false);
  cin>>n;m=n-1;
  while(m--)
  {
  	 LL x,y;cin>>x>>y;
	 tree[x].push_back(y);
	 tree[y].push_back(x);	
  } 
  dfs(1,0,-1);
  for(LL i=1;i<=n+100;i++) vis[i]=0,tree[i].clear();
  f[0]=1;
  for(LL i=1;i<=n;i++)
 {
 	tree[fa[i]].push_back(i);
  }
  dfs2(1);
  printf("%.15f\n",ans);
return 0;
}
  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值